<?php
// PHP script by newquayweather.com
// 
// Version 1.00 - 20th Jul 09 -- Initial release
// Version 1.01 - 25th Jul 09 -- preg_replace added
// Version 1.20 - 6th Oct 2010 -- 2 versions one for graph with , one for table
// version 1.30 - 15th Oct 2010 -- re write of script
// version 1.40 - 13th Dec 2014 -- update to use file_get_contents following 
//                Space Weather Prediction Center website change to ftp server
// version 1.50 - Minor change
// version 1.60 - Updated background image url
//
// Notes, Please read
// This displays the last 30 day graph
// Example my home page at http://www.newquayweather.com/wxsunspots.php
// Change settings to match your server, jpgraphs dir etc and upload
// into your wxgraphs directory, 
// Cache file, uploaded to sunspots year directory, script will create year directory
// Adjust settings to match your website location of jpgraphs cache file etc,  place the file in your
// wxgraphs  directory, and can be called with (includes link sohowww.nascom.nasa)
//
// <a href="http://sohowww.nascom.nasa.gov/data/realtime/realtime-update.html">
//   <img src="./wxgraphs/sunspots30day.php" alt="Sunspots last 30 days" border="0"/></a>
//
// Change settings to match your server
//
  $Version = 'sunspots30day.php V1.60 - 11-Apr-2022';
//
if (!file_exists("graphsconf.php")) include("error_msg.php");
include ("graphsconf.php");
if (!file_exists($jploc."jpgraph.php")) {
  $string = "Unable to find JPGraph files";
  create_image1($string,$jploc);
  exit;
}

include ($jploc."jpgraph.php");
// Comment out one
//include ($jploc."jpgraph_bar.php");
include ($jploc."jpgraph_line.php");

// cacheName is name of file used to store cached webpage
// change to match your server
  $cacheName = "/home/XXXXX/public_html/xxxxx/sunspots/".date("Y")."/sunspotscache30d.txt";
  $refetchSeconds = 3600;     // refetch every nnnn seconds 3600 = 1 hour
//
  $line = 2;      // line number starting point
  $lineend = 32;  // last line
// end of settings

// Sunspot daily totals and background image url's
// 
  $ftp_server = "ftp://ftp.swpc.noaa.gov/pub/latest/DSD.txt";
  $bgimageurl="https://soho.nascom.nasa.gov/data/realtime/hmi_igr/512/latest.jpg"; // background image 11-04-2022
//  $bgimageurl="https://sohowww.nascom.nasa.gov/data/realtime/hmi_igr/512/latest.jpg"; // background MDI image to graphs
//  $bgimageurl="http://sohowww.nascom.nasa.gov//data/realtime/hmi_igr/512/latest.jpg"; // background MDI image to graphs
//  $bgimageurl="http://sohowww.nascom.nasa.gov/data/synoptic/sunspots_earth/mdi_sunspots.jpg"; // background image to graphs
  $bgimage="${hostloc}sunspots/bgmdiimage.jpg"; // background cache image path

//
// ------ start of code -------
// check year dir exists, if not create,
// change to match your server
if (!is_dir('/home/XXXXX/public_html/xxxx/sunspots/'.date("Y"))) {
    mkdir('/home/XXXXX/public_html/xxxx/sunspots/'.date("Y"));
}

// end of settings

// background image
if (file_exists($bgimage) and filemtime($bgimage) + $refetchSeconds > time()) {
//      echo "<!-- using Cached version of jpg -->\n";
  $bgimage = "${hostloc}sunspots/bgmdiimage.jpg";
    } else {
$ch = curl_init($bgimageurl);
$fp = fopen($bgimage, 'wb');
curl_setopt($ch, CURLOPT_FILE, $fp);
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_exec($ch);
curl_close($ch);
fclose($fp);
}
// end bg image 	
//sunspot data
if (file_exists($cacheName) and filemtime($cacheName) + $refetchSeconds > time()) {
      $text = implode('', file($cacheName));
 } else {
 	$ctx = stream_context_create(array('http' => array('timeout' => 30)));
 $text=@file_get_contents($ftp_server, 0, $ctx);

file_put_contents($cacheName, ""); //zero file
while ($line < $lineend) {
$split = preg_split("/[\n]/", $text, -1, 0 );
$lastline = count($split)-$line;
$last = $split[$lastline];
$last = preg_replace('/\s\s+/', ' ', $last)."\n";
file_put_contents($cacheName, $last, FILE_APPEND);
 $line++;
}
}

// arrays
$y = array();
$a = array();

readsunspotfile($cacheName,$a,$y);

// Here we create an aray for the y-values
//$y = array(fgets($handle[$yy]));
//=================================================================================================
//here we create the labels for the x-axis depending month and year
//so if we are in March we must show the last day of Feb normally 28 or 29 and the following
//label must be 01
//same for moths with 30 days (last day = 30 next label must be 01 and not 31
//we need 31 labels because we have 31 datapoints
//==================================================================================================
//
// Create the graph. These two calls are always required
$graph = new Graph(512,572,"auto",30);	
$graph->SetScale("textlin");
$graph->yscale->SetGrace(2);
$graph->SetMargin(25,20,25,70);
$graph->ygrid->Show(false); 
//$graph->SetShadow();  //uncomment to add shadow

// Graph colors
$graph->SetBackgroundGradient('black','black',GRAD_HOR,BGRAD_PLOT);
$graph->SetMarginColor("black");
$graph->SetFrame(true,'black',1);


// Comment out this if you want bar graph
// Only one should be un commented
// Create a line plot
$lplot = new LinePlot($y);
$lplot->SetColor('yellow'); // color of y-axis graph line
$lplot->SetWeight(2);
$graph->Add($lplot);
$graph->SetBackgroundImage($bgimage,BGIMG_FILLPLOT);
// End comment out

// Comment out this if you want line graph
// Create a bar plot
//$bplot = new BarPlot($y);
//$bplot->SetWidth(0.7);
//$bplot->SetFillColor("$sunspot_col");
//$graph->Add($bplot);
//$graph->SetBackgroundImage($bgimage,BGIMG_FILLPLOT);
// End comment out

// Setup the titles
$graph->title->SetFont(FF_ARIAL,FS_BOLD,12);
$graph->title->Set("Sunspots - Last 30 days");
$graph->title->SetColor("orange"); 


//x-axis
$graph->xaxis->title->SetFont(FF_ARIAL,FS_BOLD,10);
$graph->xaxis->title->SetColor("$xtextcolour");
$graph->xaxis->SetTickLabels($a); 
$graph->xaxis->SetLabelAngle(80);
$graph->xaxis->SetLabelMargin(5); 
$graph->xaxis->SetTextLabelInterval(1);
$graph->xaxis->SetPos("min"); 
$graph->xaxis->SetFont(FF_ARIAL,FS_BOLD,8); 
$graph->xaxis->SetColor("$xtextcolour");
$graph->xaxis->HideTicks(true,false); 
$graph->xaxis->SetTickSide(SIDE_BOTTOM); 
$graph->xaxis->SetColor('white','orange'); 

//y-axis
$graph->yaxis->SetFont(FF_ARIAL,FS_BOLD,8);
$graph->yaxis->scale->SetGrace(5);
$graph->yaxis->SetLabelMargin(5); 
$graph->yaxis->SetColor('white','orange'); 

// Display the graph
$graph->Stroke();

// ----------------------------functions ----------------------------------- 
 
 function fetchUrlWithoutHangingUKQg($url) // thanks to Tom at Carterlake.org for this script fragment
   {
   // Set maximum number of seconds (can have floating-point) to wait for feed before displaying page without feed
   $numberOfSeconds=4;   

   // Suppress error reporting so Web site visitors are unaware if the feed fails
   error_reporting(0);

   // Extract resource path and domain from URL ready for fsockopen

   $url = str_replace("http://","",$url);
   $urlComponents = explode("/",$url);
   $domain = $urlComponents[0];
   $resourcePath = str_replace($domain,"",$url);

   // Establish a connection
   $socketConnection = fsockopen($domain, 80, $errno, $errstr, $numberOfSeconds);

   if (!$socketConnection)
       {
       // You may wish to remove the following debugging line on a live Web site
       //  print("<!-- Network error: $errstr ($errno) -->");
       }    // end if
   else    {
       $xml = '';
       fputs($socketConnection, "GET $resourcePath HTTP/1.0\r\nHost: $domain\r\n\r\n");
       // Loop until end of file
       while (!feof($socketConnection))
           {
           $xml .= fgets($socketConnection, 4096);
           }    // end while
       fclose ($socketConnection);
       }    // end else
   return($xml);
   }    // end function
  
function readsunspotfile($aFile, &$aYears, &$aSunspots) {
	    $lines = @file($aFile,FILE_IGNORE_NEW_LINES|FILE_SKIP_EMPTY_LINES);
    if( $lines === false ) {
        throw new JpGraphException('Can not read sunspot data file.');
    }

   foreach( $lines as $line => $datarow ) {
//   $split = preg_split("/[\n]/", $datarow, -1, 0);

 $dayspots = explode(" ", $datarow);
 $yr = $dayspots[0]; // year
 $mth = $dayspots[1]; // month
 $dy = $dayspots[2]; // day
 $spots = $dayspots[4]; // spots
 $aYears[] = $dy."-".$mth."-".$yr;
 $aSunspots[] = $spots;
    }
}

// --------------end of functions ---------------------------------------
?>
